/* FILE: mmsolve.cc                 -*-Mode: c++-*-
 *
 * Skeleton for mmsolve interpreter shell application.
 *
 */

#include <tcl.h>	/* TCL_OK, ... */
#include "mmsolve.h"	/* Mmsolve_Init, Mmsolve_SafeInit */
/* End includes */     

//#define USE_TK   // Select between Tcl and Tk interpreter

int Tcl_AppInit(Tcl_Interp *interp)
{
    if (Tcl_Init(interp) == TCL_ERROR) {
      return TCL_ERROR;
    }

    if (Oommf_Init(interp) == TCL_ERROR) {
       return TCL_ERROR;
    }
    if (Mmsolve_Init(interp) == TCL_ERROR) {
       return TCL_ERROR;
    }
    return TCL_OK;
}

int Tk_AppInit(Tcl_Interp *interp)
{
    if (Tcl_Init(interp) == TCL_ERROR) {
      return TCL_ERROR;
    }

    if (Tk_Init(interp) == TCL_ERROR) { return TCL_ERROR; }
    Tcl_StaticPackage(interp, "Tk", Tk_Init, (Tcl_PackageInitProc *) NULL);

    if (Oommf_Init(interp) == TCL_ERROR) {
       return TCL_ERROR;
    }
    if (Mmsolve_Init(interp) == TCL_ERROR) {
       return TCL_ERROR;
    }
    return TCL_OK;
}

int main(int argc, char **argv)
{
  int use_tk=0;

  // Search for the option "-tk"; if found, set use_tk to 1
  // and remove from parameter list.
  for(int i=1;i<argc;i++) {
    if(strcmp("--",argv[i])==0) break;  // End option list
    if(strcmp("-tk",argv[i])==0) {
      use_tk=1;
      for(int j=i+1;j<argc;j++) {
	argv[j-1]=argv[j];
      }
      argc--;
    }
  }

  if(use_tk)
    Tk_Main(argc, argv, Tk_AppInit);
  else
    Tcl_Main(argc, argv, Tcl_AppInit);
  return 0;
}


