# FILE: log.tcl
#
# Selects among the available log types and returns one.
#

# Only define em_log once (bootstrap protection)
if {[string match {} [info procs em_log]]} {

em_class em_log {

    constructor {args} {
        foreach pkg [info loaded ""] {
            if {[string match Tk [lindex $pkg 1]]} {
                if {[catch {eval em_widgetlog new $args} log]} {
                    error $log
                } else {
                    $this delete
                    return $log
                }
            }
        }
        if {[catch {eval em_channellog new $args} log]} {
            error $log
        } else {
            $this delete
            return $log
        }
    }
}

}
